FunXgame/FunXgame/Models/Producto.cs
//------------------------------------------------------------------------------
// <auto-generated>
//     Este código se generó a partir de una plantilla.
//
//     Los cambios manuales en este archivo pueden causar un comportamiento inesperado de la aplicación.
//     Los cambios manuales en este archivo se sobrescribirán si se regenera el código.
// </auto-generated>
//------------------------------------------------------------------------------

namespace FunXgame.Models
{
    using System;
    using System.Collections.Generic;
    
    public partial class Producto
    {
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]
        public Producto()
        {
            this.Orden_Producto = new HashSet<Orden_Producto>();
        }
    
        public int Id_producto { get; set; }
        public string Codigo_producto { get; set; }
        public int Id_estado { get; set; }
        public int Id_marca { get; set; }
        public int Id_categoria { get; set; }
        public int Id_imagen { get; set; }
        public string Nombre_producto { get; set; }
        public double Precio_producto { get; set; }
        public int Stock_producto { get; set; }
        public string Descripcion_producto { get; set; }
    
        public virtual Categoria Categoria { get; set; }
        public virtual Estado Estado { get; set; }
        public virtual Imagen Imagen { get; set; }
        public virtual Marca Marca { get; set; }
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<Orden_Producto> Orden_Producto { get; set; }
    }
}

FunXgame/FunXgame/Controllers/AdminPanelController.cs
using System;
using System.Data.Entity;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using FunXgame.Models;

namespace FunXgame.Controllers
{
    
    public class AdminPanelController : Controller
    {
        // GET: AdminPerfil
        db_FunXGameEntities db = new db_FunXGameEntities();

        public ActionResult AdminPanelMenu()
        {
            return PartialView("_AdminPanelMenu");
        }

        public ActionResult AdminPerfil()
        {
            if (Session["Admin"] != null)
            {
                int id = int.Parse(Session["Id_Admin"].ToString());
                Usuario usr = db.Usuario.Find(id);
                return View(usr);
            }
            return Redirect(Url.Content("~/Home/Index/"));
        }

        [HttpPost]
        public ActionResult AdminPerfil(Usuario usr)
        {

            usr.Id_rol = 1;
            db.Entry(usr).State = EntityState.Modified;
            db.SaveChanges();

            Session.Abandon(); //---->abandona sesión para que vuelva a ingresar con 

            return Redirect(Url.Content("~/LogIn/logIn"));
        }



       





    }
}

FunXgame/FunXgame/Controllers/ProductosController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using FunXgame.Models;
using System.Data.Entity;

namespace FunXgame.Controllers
{
    public class ProductosController : Controller
    {
        db_FunXGameEntities db = new db_FunXGameEntities();
        // GET: Productos
        public ActionResult ListarProducto()
        {
            if (Session["Admin"] == null)
            {
                return Redirect(Url.Content("~/Home/Index/"));
            }
            ViewBag.Id_estado = new SelectList(db.Estado.Where(d => d.Id_estado == 1 || d.Id_estado == 2), "Id_estado", "Nombre_estado");
            ViewBag.Id_categoria = new SelectList(db.Categoria, "Id_categoria", "Nombre_categoria");
            ViewBag.Id_marca = new SelectList(db.Marca, "Id_marca", "Nombre_marca");
            
            return View();
        }
       

        public ActionResult ListarProductoPartial(string codigo, string nombre, int? categoria , int? marca, int? estado)
        {
            if (codigo == "")
            {
                codigo = null;
            }
            if (nombre == "")
            {
                nombre = null;
            }
            var lista = db.Producto.ToList();

            if (nombre != null)
            {
                lista = lista.Where(d => d.Nombre_producto.ToLower() == nombre.ToLower()).ToList();
            }

            if (codigo != null)
            {
                lista = lista.Where(d => d.Codigo_producto.ToLower() == codigo.ToLower()).ToList();
            }

            if (categoria != null)
            {
                lista = lista.Where(d => d.Id_categoria == categoria).ToList();
            }

            if (marca != null)
            {
                lista = lista.Where(d => d.Id_marca == marca).ToList();
            }

            if (estado != null)
            {
                lista = lista.Where(d => d.Id_estado == estado).ToList();
            }           

            return PartialView("_ListarProductoPartial",lista);
        }

        

        //---->Crear
        public ActionResult CrearProducto()
        {
            ViewBag.Id_estado = new SelectList(db.Estado.Where(d => d.Id_estado == 1 || d.Id_estado == 2), "Id_estado", "Nombre_estado");
            ViewBag.Id_marca = new SelectList(db.Marca, "Id_marca", "Nombre_marca");
            //ViewBag.Id_categoria = new SelectList(db.Categoria, "Id_categoria", "Nombre_categoria");
            ViewBag.Marca_Categoria = GetMarcaCategoria();
            ViewBag.Id_imagen = new SelectList(db.Imagen.Where(d => d.Id_grupo == 1), "Id_imagen", "Nombre_imagen");
            return View();
        }

        public IEnumerable<Marca_Categoria> GetMarcaCategoria()
        {
            var lista = db.Marca_Categoria.ToList();
            return lista;
        }

        public ActionResult GetCategorias(int? id)
        {
            if (id != null)
            {
                db_FunXGameEntities db = new db_FunXGameEntities();
                return Json(db.Marca_Categoria.Where(d => d.Id_marca == id && d.Id_estado==1).Select(d => new
                {
                    nombre = d.Categoria.Nombre_categoria,
                    categoria = d.Id_categoria
                }).ToList(), JsonRequestBehavior.AllowGet);

            }
            return Json("");
        }


        [HttpPost]
        public ActionResult CrearProducto(Producto producto)
        {
            ViewBag.Id_estado = new SelectList(db.Estado.Where(d => d.Id_estado == 1 || d.Id_estado == 2), "Id_estado", "Nombre_estado");
            ViewBag.Id_marca = new SelectList(db.Marca, "Id_marca", "Nombre_marca");
            
            ViewBag.Id_imagen = new SelectList(db.Imagen.Where(d => d.Id_grupo == 1), "Id_imagen", "Nombre_imagen");
            db.Producto.Add(producto);
            db.SaveChanges();
            return View();
        }

        [HttpPost]
        public ActionResult ExisteCodigoNombreProducto(string Codigo_producto, string Nombre_producto)
        {
            var producto = db.Producto.Where(d => d.Nombre_producto.ToLower() == Nombre_producto.ToLower()).ToList();
            if (producto.Count > 0)
            {
                return Json("nombreExiste");
            }
            var producto2 = db.Producto.Where(d => d.Codigo_producto.ToLower() == Codigo_producto.ToLower()).ToList();
            if (producto2.Count > 0)
            {
                return Json("codigoExiste");
            }
            return Json("");
        }

    //---->Editar
        
        public ActionResult EditarProducto(int? id)
        {
            var lista = db.Producto.Where(d => d.Id_producto == id).ToList();
            if (id == null || lista.Count==0)
            {
                return Redirect(Url.Content("~/Productos/ListarProducto"));
            }
            if (Session["Admin"] == null)
            {
                return Redirect(Url.Content("~/Home/Index/"));
            }
            var producto = db.Producto.Find(id);

            ViewBag.Id_estado = new SelectList(db.Estado.Where(d => d.Id_estado == 1 || d.Id_estado == 2), "Id_estado", "Nombre_estado",producto.Id_estado);
            ViewBag.Id_categoria = new SelectList(db.Marca_Categoria.Where(d=>d.Id_marca==producto.Id_marca && d.Id_estado==1), "Id_categoria", "Categoria.Nombre_categoria",producto.Id_categoria);
            ViewBag.Id_marca = new SelectList(db.Marca, "Id_marca", "Nombre_marca",producto.Id_marca);
            ViewBag.Id_imagen = new SelectList(db.Imagen.Where(d => d.Id_grupo == 1), "Id_imagen", "Nombre_imagen",producto.Id_imagen);

            return View(producto);
        }

        

        [HttpPost]
        public ActionResult EditarProducto(Producto producto)
        {
            
            db.Entry(producto).State = EntityState.Modified;
            db.SaveChanges();
            return Redirect(Url.Content("~/Productos/ListarProducto/"));
        }


        [HttpPost]
        public ActionResult CodigoNombreExisteEdit(string Codigo_producto, string Nombre_producto, int Id_producto)
        {
            var producto = db.Producto.Find(Id_producto);
            var listaProductoA = db.Producto.Where(d => d.Nombre_producto == Nombre_producto).ToList();
            var listaProductoB = db.Producto.Where(d => d.Codigo_producto == Codigo_producto).ToList();
            if (listaProductoA.Count > 0 && producto.Nombre_producto.ToLower() != Nombre_producto.ToLower())
            {
                return Json("nombreExiste");
            }
            if (listaProductoB.Count > 0 && producto.Codigo_producto.ToLower() != Codigo_producto.ToLower())
            {
                return Json("codigoExiste");
            }
            return Json("");
        }



        public ActionResult CargaImgPreview(int? id)
        {
            if (id != null)
            {
                Imagen imagen = db.Imagen.Find(id);
                string ruta = imagen.Ruta;
                ruta = ruta.Substring(1);
                return Json(ruta);
            }
            return Json("");
        }

        public ActionResult CapturaEstadoMarca(int? id)
        {
            if (id != null)
            {
                var marca = db.Marca.Find(id);
                if (marca.Id_estado == 2)
                {
                    return Json("marcaDesactivada");
                }
            }
            return Json("");
        }

        public ActionResult CapturaEstadoCategoria(int? idMarca, int? idCategoria)
        {
            
            if (idCategoria != null)
            {
                var categoria = db.Categoria.Find(idCategoria);
                if (categoria.Id_estado == 2)
                {
                    return Json("categoriaDesactivada");
                }
            }
            
            return Json("");
        }

        public ActionResult EstadoProducto(int id)
        {
            var producto = db.Producto.Find(id);
            if (producto.Id_estado == 1)
            {
                producto.Id_estado = 2;
                db.Entry(producto).State = EntityState.Modified;
            }
            else
            {
                producto.Id_estado = 1;
                db.Entry(producto).State = EntityState.Modified;
            }
            db.SaveChanges();
            return Redirect(Url.Content("~/Productos/ListarProducto"));
        }
    }
}

FunXgame/FunXgame/Views/Productos/CrearProducto.cshtml
@model FunXgame.Models.Producto

@{
    ViewBag.Title = "CrearProducto";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="card text-center" style="background-color:whitesmoke">

    @{Html.RenderAction("AdminPanelMenu", "AdminPanel");}

    <div class="card-body">
        <div class="card text-left" style="background-color:whitesmoke">
            <div class="card-header">
                <ul class="nav nav-tabs card-header-tabs">
                    <li class="nav-item">
                        <a class="nav-link " style="color:black" href="~/Productos/ListarProducto">Listar Productos</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link active" style="color:white; background-color:black" href="#">Agregar Producto</a>
                    </li>
                </ul>
            </div>
            <div class="card-body text-left">

                @using (Html.BeginForm("CrearProducto", "Productos", FormMethod.Post, new { role = "form", id = "productoCreaForm", @class = "" }))
                {
                    @Html.AntiForgeryToken()

                <div class="form-horizontal">

                    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Código:</label>
                            @Html.EditorFor(model => model.Codigo_producto, new { htmlAttributes = new { @class = "form-control", id = "Codigo_producto" } })
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Estado:</label>
                            @Html.DropDownList("Id_estado", null, "Seleccione...", htmlAttributes: new { @class = "form-control", id = "Id_estado" })
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Marca:</label>
                            @Html.DropDownList("Id_marca", null, "Seleccione...", htmlAttributes: new { @class = "form-control", id = "Id_marca" })
                        </div>
                    </div>

                    <div class="form-group">
                        <div class=" col-md-10">
                            <label>Categoría:</label>
                            <select id="select_categoria" class="form-control" name="Id_categoria">
                                <option value="">Seleccione...</option>
                            </select>
                        </div>
                    </div>


                    

                    <div class="form-group">
                        <div class="col-md-10">
                            <img id=img src="~/Content/Assets/Imagenes/noImage.jpg" style="width:280px" />
                        </div>
                    </div>

                    <div class="form-group">
                        <label>Seleccione imagen:</label>
                        <div class="col-md-10">
                            @Html.DropDownList("Id_imagen", null, "Seleccione...", htmlAttributes: new { @class = "form-control", id = "img_select" })

                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Nombre:</label>
                            @Html.EditorFor(model => model.Nombre_producto, new { htmlAttributes = new { @class = "form-control", id = "Nombre_producto" } })

                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Precio:</label>
                            @Html.EditorFor(model => model.Precio_producto, new { htmlAttributes = new { @class = "form-control soloNumeros", id = "Precio_producto" } })

                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Stock:</label>
                            @Html.EditorFor(model => model.Stock_producto, new { htmlAttributes = new { @class = "form-control soloNumeros", id = "Stock_producto" } })

                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Descripción:</label>
                            @Html.EditorFor(model => model.Descripcion_producto, new { htmlAttributes = new { @class = "form-control", id = "Descripcion_producto" } })

                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-offset-2 col-md-10">
                            <input id="btnGuardar" type="submit" value="Agregar Producto" class="btn btn-dark" />
                        </div>
                    </div>
                </div>
                }

            </div>
        </div>
    </div>
</div>



@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
    <script src="~/Scripts/sweetalert.js"></script>
    <script src="~/Scripts/Validaciones/valida_producto.js"></script>

    <script>

        $(document).ready(function () {

            $('#Codigo_producto').blur(function () {
                validaCodigoNombreExiste('#Codigo_producto');
            });
            capturaIdMarca();
            capturaIdMarcaCategoria();
            $('#Nombre_producto').blur(function () {
                validaCodigoNombreExiste('#Nombre_producto');
            });

            enviaValidaProducto('Nuevo producto creado','','#productoCreaForm')
            limpiar();
        })



        $('#img_select').change(function () {
            $.ajax({
                type: 'POST',
                url: '@Url.Action("CargaImgPreview")',
                data: '{id:' + JSON.stringify($('#img_select').val()) + '}',
                dataType: 'json',
                contentType: 'application/json; charset=utf-8',
                success: function (result) {
                    if (result != "") {
                        $('#img').attr('src', result);
                        preview.style.display = "block";
                    }
                }
            });
        });

        function limpiar() {
            $('#Codigo_producto').val('');
            $('#Nombre_producto').val('');
            $('#Descripcion_producto').val('');
            $('#img_select').val('');
            $('#Precio_producto').val('');
            $('#Stock_producto').val('');
            $('#Id_marca').val('');
            $('#Id_estado').val('');

        }

        function validaCodigoNombreExiste(selector) {

            var valores = { Codigo_producto: $('#Codigo_producto').val().trim(), Nombre_producto: $('#Nombre_producto').val() };
            var resultado = JSON.stringify(valores);

            if ($(selector).val().trim() != '') {
                    $.ajax({
                        type: 'POST',
                        url: '@Url.Action("ExisteCodigoNombreProducto")',
                        data: resultado,
                        dataType: 'json',
                        contentType: 'application/json; charset=utf-8',
                        success: function (result) {
                            if (result == "codigoExiste") {
                                $('#Codigo_producto').val('');
                                swal("Ya existe un producto con ese código", "", "warning");
                            }

                            if (result == "nombreExiste") {
                                $('#Nombre_producto').val('');
                                swal("Ya existe un producto con ese nombre", "", "warning");
                            }
                        }
                    });
            }
        }

         function capturaIdMarca() {
            $('#Id_marca').change(function () {
                let idMarca = $('#Id_marca').val();

                $.ajax({
                type: 'POST',
                url: '@Url.Action("CapturaEstadoMarca")',
                data: '{id:' + JSON.stringify(idMarca) + '}',
                dataType: 'json',
                contentType: 'application/json; charset=utf-8',
                    success: function (result) {
                    //AQUI MENSAJE MARCA DESACTIVADA
                    if (result == "marcaDesactivada") {
                        swal("La marca seleccionada no se encuetra activada",'Puede reactivarla en el panel de edición de marcas.', "warning");
                    }
                    if (result == "") {

                    }
                }
                });

                $.ajax({
                type: 'POST',
                url: '@Url.Action("GetCategorias")',
                data: '{id:' + JSON.stringify(idMarca) + '}',
                dataType: 'json',
                contentType: 'application/json; charset=utf-8',
                success: function (result) {
                    if (result != "") {

                            $('#select_categoria').html('');
                            var options = '';
                            options += '<option value="">Seleccione...</option>';

                            for (var i = 0; i < result.length; i++) {


                                options += '<option value="' + result[i].categoria + '">' + result[i].nombre + '</option>';
                            }
                            $('#select_categoria').append(options);
                    }
                    if (result == "") {
                        $('#select_categoria').html('');
                        $('#select_categoria').append('<option value="">Seleccione...</option>');
                    }
                }

                });

           });
        }

        function capturaIdMarcaCategoria() {
            $('#select_categoria').change(function () {

                var valores = { idMarca: $('#Id_marca').val(), idCategoria: $('#select_categoria').val() };
                var data = JSON.stringify(valores);
                $.ajax({
                type: 'POST',
                url: '@Url.Action("CapturaEstadoCategoria")',
                data: data,
                dataType: 'json',
                contentType: 'application/json; charset=utf-8',
                success: function (result) {
                    if (result == "categoriaDesactivada") {
                        //Mensaje categoria desactivada
                        swal("La categoria seleccionada no se encuetra activada", 'Puede reactivarla en el panel de edición de categorías.', "warning");
                    }
                }

                });

           });
        }

    </script>
}

FunXgame/FunXgame/Views/Productos/ListarProducto.cshtml
@model IEnumerable<FunXgame.Models.Marca>
@{
    ViewBag.Title = "ListarProducto";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="card text-center" style="background-color:whitesmoke">
    @{Html.RenderAction("AdminPanelMenu", "AdminPanel");}


    <div class="card-body">
        <div class="card text-left" style="background-color:whitesmoke">
            <div class="card-header">
                <ul class="nav nav-tabs card-header-tabs">

                    <li class="nav-item">
                        <a class="nav-link " style="color:white;background-color:black" href="~/Productos/ListarProducto">Listar Productos</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link " style="color:black" href="~/Productos/CrearProducto">Agregar Producto</a>
                    </li>
                </ul>
            </div>
            <div class="card-body">
                <div class="form-row">
                    <div class="col-3 form-group">
                        <input class="form-control" type="text" id="Codigo_producto" value="" placeholder="Codigo producto" />
                    </div>
                    <div class="col-3 form-group">
                        <input class="form-control" type="text" id="Nombre_producto" value="" placeholder="Nombre producto" />
                    </div>
                    <div class="col-3 form-group">
                        @Html.DropDownList("Id_categoria", null, "Todas las categorías", htmlAttributes: new { @class = "form-control", id = "Id_categoria" })
                    </div>
                    <div class="col-3 form-group">
                        @Html.DropDownList("Id_marca", null, "Todas las marcas", htmlAttributes: new { @class = "form-control", id = "Id_marca" })
                    </div>
                    <div class="col-3 form-group">
                        @Html.DropDownList("Id_estado", null, "Todos los estados", htmlAttributes: new { @class = "form-control", id = "Id_estado" })
                    </div>

                    <div>
                        <button class="btn btn-dark" id="buscar">Buscar</button>
                    </div>
                </div>
                <div class="table-responsive" id="tablaProducto">
                    
                </div>
            </div>
        </div>
    </div>
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
    <script src="~/Scripts/sweetalert.js"></script>
    <script>

         $(window).on("load", function () {
             cargaTablaProducto();
         });

        $('#buscar').click(function () {
            cargaTablaProducto();
            $(this).blur();
        });

        function cargaTablaProducto() {
            let datos = '?codigo=' + $('#Codigo_producto').val() + '&nombre=' + $('#Nombre_producto').val() + '&categoria=' + $('#Id_categoria').val() + '&marca=' + $('#Id_marca').val()+ '&estado=' + $('#Id_estado').val();
                $.get('@Url.Action("ListarProductoPartial")' + datos, function (lista) {
                    $('#tablaProducto').html(lista);
                });
        }


    </script>
}


FunXgame/FunXgame/Views/Productos/_ListarProductoPartial.cshtml
@model IEnumerable<FunXgame.Models.Producto>


<table class="table">
    <tr>
        <th>
            <label>Código</label>
        </th>
        <th>
            <label>Nombre</label>
        </th>
        <th>
            <label>Categoría</label>
        </th>
        <th>
            <label>Marca</label>
        </th>
        <th>
            <label>Precio</label>
        </th>
        <th>
            <label>Stock</label>
        </th>
        <th>
            <label>Estado</label>
        </th>
        <th>
            <label>Imagen</label>
        </th>

        <th></th>
        <th></th>
        <th></th>
    </tr>

@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.Codigo_producto)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Nombre_producto)
        </td>
        <td>
           
            @Html.DisplayFor(modelItem => item.Categoria.Nombre_categoria)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Marca.Nombre_marca)
            
        </td>

        <td>
            @Html.DisplayFor(modelItem => item.Precio_producto)
        </td>
        
        <td>
            @Html.DisplayFor(modelItem => item.Stock_producto)
            
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Estado.Nombre_estado)
        </td>
        <td>
            <img src="@Url.Content(item.Imagen.Ruta)" style="height: 50px"/>
        </td>
        <td>
            
        </td>
        <td>

            @{
                string texto = "";
                int estado = item.Id_estado;
                if (estado == 1)
                {
                    texto = "Desactivar";
                }
                else
                {
                    texto = "Activar";
                }
            }

            <a class="btn btn-success" href="~/Productos/EditarProducto/@item.Id_producto" id="" style="width:100px">Editar</a>
           
        </td>
        <td>
            <a class="btn btn-secondary" href="~/Productos/EstadoProducto/@item.Id_producto" id="" style="width:100px">@texto</a>
        </td>
    </tr>
}

</table>